#!/bin/bash
# Skript zum erstellen einer Bridge fuer Virtuelle Maschinen.
# Dieses Skript legt eine Bridge an,
# setzt Masquerading, legt die routen an 
# und gibt der Bridge eine IP-Adresse.
#
# Bitte das Skript bis zum ende durchlesen 
# und genau anschauen - es kann noch fehler bzw. verbesserungen enthalten bzw. 
# es koennen noch verbesserungen vorgenommen werden -
# bei einer Ueberarbeitung wuerde ich mich freuen, wenn ich eine kurze
# Rueckmeldung bekommen koennte - ich wuerde es dann veroeffentlichen, dann 
# haben alle etwas davon!
#
# Name der Bridge festlegen
bridge=virt0


case $1 in
up|"")
# Bridge anlegen.
	brctl addbr $bridge ; rc=$?
	if [ x"$rc" == x"0" ]
	then
# Bridge konfigurieren.
		brctl stp $bridge off
		brctl sethello $bridge 2
		brctl setfd $bridge 7
		brctl setmaxage $bridge 12
                # Schalte ip_forward ein:
                # ist wichtig, damit das ganze ueberhaupt funktioniert!
#                echo 1 > /proc/sys/net/ipv4/ip_forward
# Schalte Masquerading ein, bitte das Interfaces gegebenenfalls anpassen!
		iptables -t nat -A POSTROUTING -o eth2 -j MASQUERADE
# Interface (Bridge) laden, mit IP-Adresse versehen und routen setzen.
		ip link set dev $bridge up
		ip a add 192.168.2.1/24 dev $bridge
		ip r add 192.168.2.0/24 dev $bridge
		
	fi
	;;
down)
# hier das ganze in umgekehrter Reinfolge - alles wird runtergefahren.
	ip link set dev $bridge down 
	ip r del 192.168.2.0/24 dev $bridge
	ip a del 192.168.2.1/24 dev $bridge
	for interface in $(brctl show | grep tap |sed s/^.*tap/tap/g)
	do
		brctl delif $bridge $interface &>/dev/null
	done
	brctl delbr $bridge &>/dev/null ; rc=$?
	if [ x"$rc" == x"0" ]
	then
		echo "done."
	else
		echo "Maybe not really done... please check!"
	fi 
	;;
*)
	echo "usage: use up to start, or down to stop!"
	;;
esac

# always return with RC=0
# important for pre-up or pre-down skripts in interfaces 

true
